// ==UserScript==
// @include http://grooveshark.com/*
// ==/UserScript==


/* All files that are needed from the local file system */
var files = new Array("GrooveFix.xml", "sidebar.html", "grooveshark.html", "initiateSession.json", "GrooveIcon128.base64", "../manifest.json");
var fileData = new Object();
/* Opera specific config (for version) */
var operaConfig = "../config.xml";

/* Variables for fetching the Grooveshark(tm) session */
var uuid = guidGenerator().toUpperCase();
var sessionUrl = "http://grooveshark.com/more.php?initiateSession";

/* Browser detection */
function isChrome() {
	try {
		if (chrome) {
			return true;
		}
	} catch (ex) { }
	return false;
}
function isOpera() {
	try {
		if (opera) {
			return true;
		}
	} catch (ex) { }
	return false;
}
function isFirefox() {
	try {
		if (Application.extensions) {
			return true;
		}
	} catch (ex) { }
	return false;
}

/* Document Manipulation */
function overwriteHtml(body) {
	document.close();
	document.open();
	document.write(replaceAds(body));
	document.close();
	
}

function replaceAds(body) {
	try {
		var sidebar = getFileContent("sidebar.html");
		sidebar = sidebar.replace("{SciLorsVersion}", getVersion());
		if (isOpera()) {
			sidebar = sidebar.replace("{SciLorsGrooveIcon128}", getFileContent("GrooveIcon128.base64"));
		} else {
			sidebar = sidebar.replace("{SciLorsGrooveIcon128}", getLocalUrl("GrooveIcon128.png"));
		}
		body = body.replace("{SciLorsSidebar}", sidebar);
		return body;
	} catch (e) { return body;  }
}


function getLocalUrl(file) {
	if (isChrome()) {
		return chrome.extension.getURL("includes/"+file);
	} else if (isOpera) {
		return file;
	} else if (isFirefox()) {
		return "chrome://SciLorsGrooveUnlocker/content/"+file;
	}
}
function getVersion() {
	if (isChrome()) {
		return JSON.parse(getFileContent("../manifest.json"))["version"];
	} else if (isOpera()) {
		return getFileXML(operaConfig).getElementsByTagName('widget').item(0).getAttribute("version");
	} else if (isFirefox()) {
		return Application.extensions.get("SciLorsGrooveUnlocker@scilor.com").version;
	}
}
function getXMLHttpRequest() {
	if (isChrome()) {
		return new XMLHttpRequest();
	} else if (isOpera()) {
		return new window.XMLHttpRequest();
		//throw "Don't use Ajax in here, need to be processed in the backgound.html!";
	} else if (isFirefox()) {
		return new XMLHttpRequest();
	}
}

function attachDomLoaded (callback) {
    /* Internet Explorer */
    /*@cc_on
    @if (@_win32 || @_win64)
        document.write('<script id="ieScriptLoad" defer src="//:"><\/script>');
        document.getElementById('ieScriptLoad').onreadystatechange = function() {
            if (this.readyState == 'complete') {
                callback();
            }
        };
    @end @*/
    /* Mozilla, Chrome, Opera */
    if (document.addEventListener) {
        document.addEventListener('DOMContentLoaded', callback, false);
    }
    /* Safari, iCab, Konqueror */
	/*
    if (/KHTML|WebKit|iCab/i.test(navigator.userAgent)) {
        var DOMLoadTimer = setInterval(function () {
            if (/loaded|complete/i.test(document.readyState)) {
                callback();
                clearInterval(DOMLoadTimer);
            }
        }, 10);
    }
	*/
    /* Other web browsers */
    window.onload = callback;
};

if (isOpera()) {
	opera.extension.onmessage = function(e) {
		fileData[e.data.path] = e.data;
	};
}

attachDomLoaded(start);

function start() {
	if (document.body.innerText.indexOf('GEMA')>0) {
		loadAllFiles();
	} else {
	
	}
}

function loadedAllFiles() {
	for (var i=0; i<files.length; i++) {
		var file = files[i];
		if (fileData[getLocalUrl(file)] == null) return false;
	}
	return true;
}

function loadAllFiles() {
	if (isOpera()) {
		files.push(operaConfig);
	}
	for (var i=0; i<files.length; i++) {
		var file = files[i];
		if (isChrome() || isFirefox()) {
			fileData[getLocalUrl(file)] = getAjaxGet(getLocalUrl(file));
		} else if (isOpera()) {
			opera.extension.postMessage({
				action: "ajax",
				path: getLocalUrl(file),
				type: "GET",
				data: null
			});
		}
	}
	waitForFiles();
}
function waitForFiles() {
	if (!loadedAllFiles()) {
		setTimeout("waitForFiles()", 100);		
		return;
	} 
	
	if (isOpera()) {
		for (var i=0; i<files.length; i++) {
			var file = files[i];
			try {
				var dom = new window.DOMParser();
				fileData[getLocalUrl(file)].responseXML = dom.parseFromString(
					getFileContent(file),
					"text/xml"
				);
			} catch (e) { }
		}
	}
	
	initiateSession();
}

function getFileContent(path) {
	return fileData[getLocalUrl(path)].responseText;
}
function getUrlContent(url) {
	return fileData[url].responseText;
}
function getFileXML(path) {
	return fileData[getLocalUrl(path)].responseXML;
}
		
function initiateSession() {
	var grooveFix = getFileXML("GrooveFix.xml");
	var htmlshark = grooveFix.getElementsByTagName('htmlshark').item(0);
	var client = htmlshark.getElementsByTagName('GrooveClient').item(0).firstChild.nodeValue;
	var clientRevision = htmlshark.getElementsByTagName('GrooveClientRevision').item(0).firstChild.nodeValue;
	var sessionParam = getFileContent("initiateSession.json");

	sessionParam = sessionParam.replace("{SciLorsGroovesharkUUID}", uuid);
	sessionParam = sessionParam.replace("{SciLorsClient}", client);
	sessionParam = sessionParam.replace("{SciLorsClientRevision}", clientRevision);
	if (isChrome() || isFirefox() || isOpera()) {
		fileData[sessionUrl] = getAjaxPost(sessionUrl, sessionParam);
	} else if (isOpera()) {
		opera.extension.postMessage({
			action: "ajax",
			path: sessionUrl,
			type: "POST",
			data: sessionParam
		});
	}
	waitForSession();
}
function waitForSession() {
	if (fileData[sessionUrl] == null) {
		setTimeout("waitForSession()", 100);		
		return;
	}
	
	var session = JSON.parse(getUrlContent(sessionUrl))["result"];
	var html = getFileContent("grooveshark.html");
	html = html.replace("{SciLorsGroovesharkUUID}", uuid);
	html = html.replace("{SciLorsGroovesharkSession}", session);
	overwriteHtml(html);	
}

function getAjax(path, type, data) {
	var ajax = getXMLHttpRequest();
	ajax.open(type, path, false);
	if (type=="POST") {
		ajax.send(data);
	} else {
		ajax.send();
	}
	return ajax;
}
function getAjaxGet(path) {
	return getAjax(path, "GET", null);
}
function getAjaxPost(path, data) {
	return getAjax(path, "POST", data);
}

//Source: http://p2p.wrox.com/topicindex/20339.htm
function guidGenerator() {
	var S4 = function () {
		return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
	};
	return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}